//+------------------------------------------------------------------+
//|                                              EventProcessor9.mq5 |
//|                                           Copyright 2014, denkir |
//|                           https://login.mql5.com/ru/users/denkir |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, denkir"
#property link      "https://login.mql5.com/ru/users/denkir"
#property version   "1.00"

//+------------------------------------------------------------------+
//| Easy access to the trade functions                               |
//+------------------------------------------------------------------+
#include <Trade\Trade.mqh>

//+------------------------------------------------------------------+
//| Iputs                                                            |
//+------------------------------------------------------------------+
sinput string Info_trade="+===--Trade--====+";   // +===--Trade--====+
input double InpLot=0.02;                        // Lot
input int InpStopLoss=125;                       // Stop Loss
input int InpTakeProfit=250;                     // Take Profit
input int InpSlippage=50;                        // Slippage

//---   
string gEdit_name="Text_edit";
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---         
   if(ObjectCreate(0,gEdit_name,OBJ_EDIT,0,0,0))
      //---   
      if(ObjectSetString(0,gEdit_name,OBJPROP_TEXT,"Text"))
         //---   
         if(ObjectSetInteger(0,gEdit_name,OBJPROP_FONTSIZE,14))
            //---    
            if(ObjectSetInteger(0,gEdit_name,OBJPROP_READONLY,false))
               //---   
               if(ObjectSetInteger(0,gEdit_name,OBJPROP_XDISTANCE,50))
                  if(ObjectSetInteger(0,gEdit_name,OBJPROP_YDISTANCE,50))
                     //---  
                     if(ObjectSetInteger(0,gEdit_name,OBJPROP_XSIZE,150))
                        if(ObjectSetInteger(0,gEdit_name,OBJPROP_YSIZE,50))
                           //---   
                           if(ObjectSetInteger(0,gEdit_name,OBJPROP_COLOR,clrGray))
                              //---   
                              if(ObjectSetInteger(0,gEdit_name,OBJPROP_BGCOLOR,clrWhite))
                                 //---   
                                 if(ObjectSetInteger(0,gEdit_name,OBJPROP_SELECTABLE,false))
                                    //---    
                                    if(ObjectSetInteger(0,gEdit_name,OBJPROP_ALIGN,ALIGN_CENTER))
                                      {
                                       //---  
                                       ChartRedraw();
                                       //---
                                       return INIT_SUCCEEDED;
                                      }

//---
   return INIT_FAILED;
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   if(ObjectFind(0,gEdit_name)>-1)
      ObjectDelete(0,gEdit_name);
//---
   ChartRedraw();
//---
   Comment("");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,//  :
                  const long   &lparam,
                  const double &dparam,
                  const string &sparam
                  )
  {
   string comment=" : ";

//---   
   switch(id)
     {
      //--- 1
      case CHARTEVENT_KEYDOWN:
        {
         comment+="1)  ";
         //---
         break;
        }
      //--- 2
      case CHARTEVENT_MOUSE_MOVE:
        {
         comment+="2) ";
         //---
         break;
        }
      //--- 3
      case CHARTEVENT_OBJECT_CREATE:
        {
         comment+="3)   ";
         //---
         break;
        }
      //--- 4
      case CHARTEVENT_OBJECT_CHANGE:
        {
         comment+="4)      ";
         //---
         break;
        }
      //--- 5
      case CHARTEVENT_OBJECT_DELETE:
        {
         comment+="5)   ";
         //---
         break;
        }
      //--- 6
      case CHARTEVENT_CLICK:
        {
         comment+="6)    ";
         //---   
         break;
        }
      //--- 7
      case CHARTEVENT_OBJECT_CLICK:
        {
         comment+="7)     ";
         //---
         break;
        }
      //--- 8
      case CHARTEVENT_OBJECT_DRAG:
        {
         comment+="8)      ";
         //---
         break;
        }
      //--- 9
      case CHARTEVENT_OBJECT_ENDEDIT:
        {
         comment+="9)      ";
         //---
         string curr_obj_name=sparam;
         //---     
         if(!StringCompare(curr_obj_name,gEdit_name))
           {
            //---   
            string obj_text=NULL;
            if(ObjectGetString(0,curr_obj_name,OBJPROP_TEXT,0,obj_text))
              {
               //---  
               if(!StringCompare(obj_text,"Buy",false))
                 {
                  if(TryToBuy())
                     //---   
                     ObjectSetInteger(0,gEdit_name,OBJPROP_COLOR,clrBlue);
                 }
               else if(!StringCompare(obj_text,"Sell",false))
                 {
                  if(TryToSell())
                     //---   
                     ObjectSetInteger(0,gEdit_name,OBJPROP_COLOR,clrRed);
                 }
               else
                 {
                  //---   
                  ObjectSetInteger(0,gEdit_name,OBJPROP_COLOR,clrGray);
                 }
               //---  
               ChartRedraw();
              }
           }
         //---
         break;
        }
      //--- 10
      case CHARTEVENT_CHART_CHANGE:
        {
         comment+="10)  ";
         //---
         break;
        }
     }

//---
   Comment(comment);
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
bool TryToBuy(void)
  {
   bool is_done=false;
//---
   CTrade myTrade;
   MqlTick last_tick;
//---   
   if(SymbolInfoTick(_Symbol,last_tick))
     {
      myTrade.SetDeviationInPoints(InpSlippage);
      //--- 
      double open_pr,sl_pr,tp_pr;
      open_pr=sl_pr=tp_pr=WRONG_VALUE;
      //---
      open_pr=NormalizeDouble(last_tick.ask,_Digits);
      sl_pr=NormalizeDouble(open_pr-_Point*InpStopLoss,_Digits);
      tp_pr=NormalizeDouble(open_pr+_Point*InpTakeProfit,_Digits);

      //---   
      is_done=myTrade.Buy(InpLot,_Symbol,open_pr,sl_pr,tp_pr);
     }
//---
   return is_done;
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
bool TryToSell(void)
  {
   bool is_done=false;
//---
   CTrade myTrade;
   MqlTick last_tick;
//---   
   if(SymbolInfoTick(_Symbol,last_tick))
     {
      myTrade.SetDeviationInPoints(InpSlippage);
      //--- 
      double open_pr,sl_pr,tp_pr;
      open_pr=sl_pr=tp_pr=WRONG_VALUE;
      //---
      open_pr=NormalizeDouble(last_tick.bid,_Digits);
      sl_pr=NormalizeDouble(open_pr+_Point*InpStopLoss,_Digits);
      tp_pr=NormalizeDouble(open_pr-_Point*InpTakeProfit,_Digits);

      //---   
      is_done=myTrade.Sell(InpLot,_Symbol,open_pr,sl_pr,tp_pr);
     }
//---
   return is_done;
  }
//+------------------------------------------------------------------+
